;; Printing functions for use with loadflow calculations
;; Requires loadf_.lisp, which has relevant definitions

;; Print description of current graph.  Each transmission line is
;; represented once, from smaller numbered node to larger

(defun printg ()
 (*let ((more act))
       (declare (type Boolean-pvar more))
    (let ((n 0) (k 0) (nt 0))
        (declare (type fixnum n k nt d))
     (do ()
         ((null (*when more (setq n (*min myx)))))
      (*when more
       (format t "~%~4D" n)
       (let ((pl (grid n 0)))
         (if (pref gen pl)
           (format t "  Generator   p = ~10,5F,  u = ~10,5F~%"
                                (pref p pl)  (pref u pl))
           (format t "  Load   p = ~10,5F,  q = ~10,5F~%  "
                            (pref p pl) (pref q pl)))
       ) ; end let
       (setq k 0)  ;; k is number of edges so far on the current line
       (*when (=!! myx (!! n))
          (do-for-selected-processors (c)
	     (setq nt (grid-from-cube-address (pref to c) 0))
	     (when (> nt n) ;; Because of symmetry
	       (if (> (incf k) 2)
                  (progn (terpri) (setq k 1))
                  (if (> k 1) (princ ",")))
	       (format t " ~4D ~10,5F ~10,5F"
                             nt (pref gm c) (pref bm c)))) ; end do-for-
	  (*set more nil!!)
        )  ; end *when =!!
       )))) ; end *when more, end do, end let, end *let
 ) ; end printg

;; Print network status

(defun prnet ()
  (let ((nx 0) (y 0) pl gn)
    (format t
          "~%Node   Type          p        u or q       v          w")
    (*when act (setq nx (1+ (*max myx))))
    (dotimes (x nx)
      (setq pl (grid x 0))  (setq gn (pref gen pl))
      (format t "~%~4D " x)
      (princ (if gn "Generator" "Load     "))
      (format t " ~10,5F ~10,5F ~10,5F ~10,5F"
                (pref p pl) (pref (if gn u q) pl) (pref v pl) (pref w pl))
    ) ; end dotimes
  ) ; end let
)

;; Print network status with answers supplied externally

(defun prnetans ()
  (let ((nx 0) (y 0) pl gn)
    (format t
"~%Node   Type     p        u or q       v         YWv         w         YWw")
    (*when act (setq nx (1+ (*max myx))))
    (dotimes (x nx)
      (setq pl (grid x 0))  (setq gn (pref gen pl))
      (format t "~%~4D " x)
      (princ (if gn " GN " " LD "))
      (format t " ~10,5F ~10,5F ~10,5F ~10,5F ~10,5F ~10,5F"
               (pref p pl) (pref (if gn u q) pl) (pref v pl) (aref vans x)
                                                 (pref w pl) (aref wans x))
    ) ; end dotimes
  ) ; end let
)
      
;; Print single-float pvar defined on nodes

(*defun ppvn (fpv)
 (declare (type single-float-pvar fpv))
 (let ((nx 0) (k 0) pl)
   (*when act (setq nx (1+ (*max myx))))
   (dotimes (x nx)
     (if (> (incf k) 3) (progn (terpri) (setq k 1)) (if (> k 1) (princ ",")))
     (format t " ~4D ~16G" x (pref fpv (grid x 0)))
 )) ; end dotimes, end let
)

;; Print Boolean pvar compactly according to grid

(*defun pb (bpv)
 (declare (type Boolean-pvar bpv))
 (let ((nx 0) (y 0))
  (*when act (setq nx (1+ (*max myx))))
  (dotimes (x nx)
    (terpri)
    (dotimes (y mxe) (write-char (if (pref bpv (grid x y)) #\T #\F))))
 )
)

